﻿local WhoPinged = WhoPinged;
local L = LibStub("AceLocale-3.0"):GetLocale("WhoPinged");

WhoPinged.options = {
	name = L["Who Pinged?"],
	type = 'group',
	args = {
		Disabled = {
			type = "toggle",
			name = L["Disable Who Pinged?"],
			desc = L["Disables Who Pinged?."],
			width = "full",
			get = function(info) return WhoPinged.db.profile.Disabled; end,
			set = function(info, v) WhoPinged.db.profile.Disabled = v; end,
			order = 10
		},
		ServerTime = {
			type = "toggle",
			name = L["Display Server Time"],
			desc = L["Displays Server Time when a player pings (if unchecked it'll display local time)."],
			width = "full",
			get = function(info) return WhoPinged.db.profile.ServerTime; end,
			set = function(info, v) WhoPinged.db.profile.ServerTime = v; end,
			order = 20
		},
		DisableInBG = {
			type = "toggle",
			name = L["Disable Who Pinged? in Battlegrounds"],
			desc = L["Disables Who Pinged? while you are in a battleground."],
			width = "full",
			get = function(info) return WhoPinged.db.profile.DisableInBG; end,
			set = function(info, v) WhoPinged.db.profile.DisableInBG = v; end,
			order = 30
		},
		Output = {
			type = "select",
			values = {
				[1] = L["Self"],
				[2] = L["Party"],
				[3] = L["Raid"],
				[4] = L["Say"],
				[5] = L["Yell"],
			},
			name = L["Output:"],
			desc = L["Where ping message will be displayed."],
			width = "100",
			get = function(info) return WhoPinged.db.profile.Output; end,
			set = function(info, v) WhoPinged.db.profile.Output = v; end,
			order = 40
		},
	}
}
		

