﻿--[[Written by: David
Contact:
	In Game: Zalra @ Hyjal (Alliance)
	Email: Davieboy53@yahoo.com
	XFire: Dawnseclipse	
	Curse/Wowace/WowInterface Username: davie3
]]

WhoPinged = LibStub("AceAddon-3.0"):NewAddon("WhoPinged", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local AceConfig = LibStub("AceConfigDialog-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("WhoPinged");

local PlayerWhoPinged;
local PingedMessage;
local ClassColor;
local hour,minute,seconds;
local BgDisable = false;

function WhoPinged:OnInitialize()
	WhoPinged:RegisterEvent("MINIMAP_PING", "MapPing")
	WhoPinged:RegisterEvent("PLAYER_ENTERING_WORLD", "EnteringWorldOnEvent")
	
	WhoPinged:RegisterChatCommand("whopinged", "ChatCommand")
	WhoPinged:RegisterChatCommand("wp", "ChatCommand")
	
	WhoPinged.db = LibStub("AceDB-3.0"):New("WhoPingedDB", WhoPinged.defaults, "profile");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("WhoPinged", WhoPinged.options)
	AceConfig:AddToBlizOptions("WhoPinged", "Who Pinged?".." v"..GetAddOnMetadata("WhoPinged", "Version"));
end

function WhoPinged:OnEnable()
	if (WhoPinged.db.profile.Disabled == false) then
		WhoPinged:Print("Enabled");
	else
		WhoPinged:Print("Disabled");
	end
end

function WhoPinged:ChatCommand()
	InterfaceOptionsFrame_OpenToCategory("Who Pinged?".." v"..GetAddOnMetadata("WhoPinged", "Version"));
end

function WhoPinged:MapPing()
	if (WhoPinged.db.profile.Disabled == false) and (BgDisable == false) then
		WhoPinged:Ping(arg1);		
	end
end

function WhoPinged:EnteringWorldOnEvent()
	local inInstance, instanceType = IsInInstance()
	if (inInstance == 1) and (instanceType == "pvp") and (WhoPinged.db.profile.DisableInBG == true) then
		BgDisable = true;
	else
		BgDisable = false;
	end
end

function WhoPinged:Ping(UnitId)
	PlayerWhoPinged = UnitName(UnitId);	
	if (UnitIsVisible(UnitId) == 1) then
		WhoPinged:PrintMessage(PlayerWhoPinged, UnitId);
	end
end

function WhoPinged:PrintMessage(Name, UnitId)
	if (WhoPinged.db.profile.ServerTime == false) then
		hour, minute, seconds = tonumber(date("%H")), tonumber(date("%M")), tonumber(date("%S"));
	else
		hour,minute = GetGameTime();
		seconds = tonumber(date("%S"));
	end
	if (hour >= 13) then
		hour = hour - 12;
	end
	
	if (WhoPinged:GetOutPutType(WhoPinged.db.profile.Output) == "print") then
		PingedMessage = "|c"..WhoPinged:GetClassColor(UnitId)..""..Name.."|r |c00CCCCCC"..L["pinged the minimap at"].." ";
	else
		PingedMessage = "<WhoPinged> "..Name.." "..L["pinged the minimap at"].." ";
	end	
	if (minute < 10) then
		PingedMessage = PingedMessage..hour..":0"..minute;
	else
		PingedMessage = PingedMessage..hour..":"..minute;
	end
	if (seconds < 10) then
		PingedMessage = PingedMessage..":0"..seconds;
	else
		PingedMessage = PingedMessage..":"..seconds;
	end
	if (WhoPinged.db.profile.ServerTime == true) then
		PingedMessage = PingedMessage.." "..L["server time."]
	else
		PingedMessage = PingedMessage.." "..L["local time."]
	end
	if (WhoPinged:GetOutPutType(WhoPinged.db.profile.Output) == "print") then
		PingedMessage = PingedMessage.."|r"
	end
	
	WhoPinged:OutPut(PingedMessage, WhoPinged:GetOutPutType(WhoPinged.db.profile.Output));
end

function WhoPinged:GetClassColor(UnitId)
	local localizedclass = UnitClass(UnitId);
	ClassColor = "";
	if (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["DEATHKNIGHT"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["DEATHKNIGHT"])) then
		ClassColor = "00C41F3B";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["DRUID"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["DRUID"])) then
		ClassColor = "00FF7D0A";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["HUNTER"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["HUNTER"])) then
		ClassColor = "00ABD473";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["MAGE"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["MAGE"])) then
		ClassColor = "0069CCF0";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["PALADIN"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["PALADIN"])) then
		ClassColor = "00F58CBA";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["PRIEST"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["PRIEST"])) then
		ClassColor = "00FFFFFF";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["ROGUE"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["ROGUE"])) then
		ClassColor = "00FFF569";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["SHAMAN"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["SHAMAN"])) then
		ClassColor = "002459FF";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["WARLOCK"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["WARLOCK"])) then
		ClassColor = "009482CA";
	elseif (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_MALE["WARRIOR"])) or (string.lower(localizedclass) == string.lower(LOCALIZED_CLASS_NAMES_FEMALE["WARRIOR"])) then
		ClassColor = "00C79C6E";
	end
	
	if (ClassColor == nil) or (ClassColor == "") then
		ClassColor = "00CCCCCC";
	end
	
	return ClassColor;
end

function WhoPinged:OutPut(msg, output)
	if (string.lower(output) == "raid") then
		if (UnitInRaid("player")) then
			SendChatMessage(msg, "RAID");
		end
	elseif (string.lower(output) == "raidwarning") then
		if (UnitInRaid("player")) then
			if (IsRaidLeader()) or (IsRaidOfficer()) then	
				SendChatMessage(msg, "RAID_WARNING");
			else
				SendChatMessage(msg, "RAID");
			end
		end
	elseif (string.lower(output) == "party") then
		if (UnitInParty("player")) and (GetNumPartyMembers() > 1) then
			SendChatMessage(msg, "PARTY");
		end
	elseif (string.lower(output) == "say") then
		SendChatMessage(msg, "SAY");
	elseif (string.lower(output) == "yell") then
		SendChatMessage(msg, "YELL");
	elseif (string.lower(output) == "print") then
		WhoPinged:Print(msg);
	elseif (string.lower(output) == "guild") then
		SendChatMessage(msg, "GUILD");
	end
end

function WhoPinged:GetOutPutType(OptionsValue)
	local Output;
	if (OptionsValue == 1) then
		Output = "print";
	elseif (OptionsValue == 2) then
		Output = "party";
	elseif (OptionsValue == 3) then
		Output = "raidwarning";
	elseif (OptionsValue == 4) then
		Output = "say";
	elseif (OptionsValue == 5) then
		Output = "yell";
	end
	return Output;
end

